Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 1975)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 1976)
@@ -2451,5 +2410,5 @@
 ! Description:
 ! ------------
-!> Soubroutine for averaging 3D data
+!> Subroutine for averaging 3D data
 !------------------------------------------------------------------------------!
 SUBROUTINE lsm_3d_data_averaging( mode, variable )
@@ -2805,37 +2764,37 @@
 ! Description:
 ! ------------
-!> Soubroutine defines appropriate grid for netcdf variables.
+!> Subroutine defining appropriate grid for netcdf variables.
 !> It is called out from subroutine netcdf.
 !------------------------------------------------------------------------------!
-    SUBROUTINE lsm_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
+ SUBROUTINE lsm_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
     
-        IMPLICIT NONE
-
-        CHARACTER (LEN=*), INTENT(IN)  ::  var         !< 
-        LOGICAL, INTENT(OUT)           ::  found       !< 
-        CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !< 
-        CHARACTER (LEN=*), INTENT(OUT) ::  grid_y      !< 
-        CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !< 
-
-
-
-!
-!--     Check for the grid
-        SELECT CASE ( TRIM( var ) )
-
-           CASE ( 'm_soil', 't_soil' )
-              found  = .TRUE.
-              grid_x = 'x'
-              grid_y = 'y'
-              grid_z = 'zs'
-
-           CASE DEFAULT
-              found  = .FALSE.
-              grid_x = 'none'
-              grid_y = 'none'
-              grid_z = 'none'
-        END SELECT
-
-    END SUBROUTINE lsm_define_netcdf_grid
+     IMPLICIT NONE
+
+     CHARACTER (LEN=*), INTENT(IN)  ::  var         !< 
+     LOGICAL, INTENT(OUT)           ::  found       !< 
+     CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !< 
+     CHARACTER (LEN=*), INTENT(OUT) ::  grid_y      !< 
+     CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !< 
+
+     found  = .TRUE.
+
+!
+!--  Check for the grid
+     SELECT CASE ( TRIM( var ) )
+
+        CASE ( 'm_soil', 't_soil', 'm_soil_xy', 't_soil_xy', 'm_soil_xz',      &
+               't_soil_xz', 'm_soil_yz', 't_soil_yz' )
+           grid_x = 'x'
+           grid_y = 'y'
+           grid_z = 'zs'
+
+        CASE DEFAULT
+           found  = .FALSE.
+           grid_x = 'none'
+           grid_y = 'none'
+           grid_z = 'none'
+     END SELECT
+
+ END SUBROUTINE lsm_define_netcdf_grid
 
 !------------------------------------------------------------------------------!
@@ -2843,15 +2802,13 @@
 ! Description:
 ! ------------
-!> Soubroutine defines 3D output variables
+!> Subroutine defining 3D output variables
 !------------------------------------------------------------------------------!
  SUBROUTINE lsm_data_output_2d( av, variable, found, grid, mode, local_pf,     &
                                 two_d, nzb_do, nzt_do )
  
-
     USE indices
 
     USE kinds
 
-    USE user
 
     IMPLICIT NONE
@@ -3174,5 +3131,5 @@
 ! Description:
 ! ------------
-!> Soubroutine defines 3D output variables
+!> Subroutine defining 3D output variables
 !------------------------------------------------------------------------------!
  SUBROUTINE lsm_data_output_3d( av, variable, found, local_pf )
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 1975)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 1976)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Removed remaining 2D land surface quantities. Definition of radiation 
+! quantities is now done directly in the respective module
 ! 
 ! Former revisions:
@@ -148,4 +149,6 @@
 !> @todo calculation of output time levels for parallel NetCDF still does not
 !>       cover every exception (change of dt_do, end_time in restart)
+!> @todo timeseries and profile output still needs to be rewritten to allow
+!>       modularization
 !------------------------------------------------------------------------------!
  MODULE netcdf_interface
@@ -414,4 +417,7 @@
     USE profil_parameter,                                                      &
         ONLY:  crmax, cross_profiles, dopr_index, profile_columns, profile_rows
+
+    USE radiation_model_mod,                                                   &
+        ONLY: radiation, radiation_define_netcdf_grid
 
     USE spectra_mod,                                                           &
@@ -735,6 +741,5 @@
                 CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',    &
                        'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',        &
-                       'rad_lw_cs_hr', 'rad_lw_hr', 'rad_sw_cs_hr',            &
-                       'rad_sw_hr', 'rho', 's', 'sa', 'vpt'  )
+                       'rho', 's', 'sa', 'vpt'  )
 
                    grid_x = 'x'
@@ -757,6 +762,5 @@
 !
 !--             w grid
-                CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_sw_in', 'rad_sw_out',   &
-                       'w' )
+                CASE ( 'w' )
 
                    grid_x = 'x'
@@ -772,4 +776,12 @@
                       CALL lsm_define_netcdf_grid( domask(mid,av,i), found,    &
                                                    grid_x, grid_y, grid_z )
+                   ENDIF
+
+!
+!--                Check for radiation quantities
+                   IF ( .NOT. found  .AND.  radiation )  THEN
+                      CALL radiation_define_netcdf_grid( domask(mid,av,i),     &
+                                                         found, grid_x, grid_y,&
+                                                         grid_z )
                    ENDIF
 
@@ -1239,6 +1251,5 @@
                 CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',    &
                        'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv', 'rho', &
-                       's', 'sa', 'vpt' , 'rad_lw_cs_hr', 'rad_lw_hr',         &
-                       'rad_sw_cs_hr', 'rad_sw_hr' )
+                       's', 'sa', 'vpt' )
 
                    grid_x = 'x'
@@ -1261,6 +1272,5 @@
 !
 !--             w grid
-                CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_sw_in', 'rad_sw_out',   &
-                       'w' )
+                CASE ( 'w' )
 
                    grid_x = 'x'
@@ -1275,5 +1285,13 @@
                    IF ( land_surface )  THEN
                       CALL lsm_define_netcdf_grid( do3d(av,i), found, grid_x,  &
-                                                    grid_y, grid_z )
+                                                   grid_y, grid_z )
+                   ENDIF
+
+!
+!--                Check for radiation quantities
+                   IF ( .NOT. found  .AND.  radiation )  THEN
+                      CALL radiation_define_netcdf_grid( do3d(av,i), found,    &
+                                                         grid_x, grid_y,       &
+                                                         grid_z )
                    ENDIF
                    
@@ -1837,7 +1855,6 @@
                              'pr_xy', 'prr_xy', 'pt_xy', 'q_xy', 'qc_xy',      &
                              'ql_xy', 'ql_c_xy', 'ql_v_xy', 'ql_vp_xy',        &
-                             'qr_xy', 'qv_xy', 'rad_lw_cs_hr_xy',              &
-                             'rad_lw_hr_xy', 'rad_sw_cs_hr_xy', 'rad_sw_hr_xy',& 
-                             'rho_xy', 's_xy', 'sa_xy', 'vpt_xy' )
+                             'qr_xy', 'qv_xy', 'rho_xy', 's_xy', 'sa_xy',      &
+                             'vpt_xy' )
 
                          grid_x = 'x'
@@ -1860,22 +1877,34 @@
 !
 !--                   w grid
-                      CASE ( 'rad_lw_in_xy', 'rad_lw_out_xy', 'rad_sw_in_xy',  &
-                             'rad_sw_out_xy' , 'w_xy' )
+                      CASE ( 'w_xy' )
 
                          grid_x = 'x'
                          grid_y = 'y'
                          grid_z = 'zw'
-!
-!--                   soil grid
-                      CASE ( 'm_soil_xy', 't_soil_xy' )
-                         grid_x = 'x'
-                         grid_y = 'y'
-                         grid_z = 'zs'
+
 
                       CASE DEFAULT
 !
+!--                      Check for land surface quantities
+                         IF ( land_surface )  THEN
+                            CALL lsm_define_netcdf_grid( do2d(av,i), found,    &
+                                                   grid_x, grid_y, grid_z )
+                         ENDIF
+
+!
+!--                      Check for radiation quantities
+                         IF ( .NOT. found  .AND.  radiation )  THEN
+                            CALL radiation_define_netcdf_grid( do2d(av,i),     &
+                                                         found, grid_x, grid_y,&
+                                                         grid_z )
+                         ENDIF
+
+!
 !--                      Check for user-defined quantities
-                         CALL user_define_netcdf_grid( do2d(av,i), found, &
-                                                       grid_x, grid_y, grid_z )
+                         IF ( .NOT. found )  THEN
+                            CALL user_define_netcdf_grid( do2d(av,i), found,   &
+                                                          grid_x, grid_y,      &
+                                                          grid_z )
+                         ENDIF
 
                          IF ( .NOT. found )  THEN
@@ -2491,7 +2520,5 @@
                           'prr_xz', 'pt_xz', 'q_xz', 'qc_xz', 'ql_xz',         &
                           'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz', 'qv_xz',  &
-                          'rad_lw_cs_hr_xz', 'rad_lw_hr_xz',                   &
-                          'rad_sw_cs_hr_xz', 'rad_sw_hr_xz''rho_xz', 's_xz',   &
-                          'sa_xz', 'vpt_xz' )
+                          'rho_xz', 's_xz', 'sa_xz', 'vpt_xz' )
 
                       grid_x = 'x'
@@ -2514,6 +2541,5 @@
 !
 !--                w grid
-                   CASE ( 'rad_lw_in_xz', 'rad_lw_out_xz', 'rad_sw_in_xz',     &
-                          'rad_sw_out_xz', 'w_xz' )
+                   CASE ( 'w_xz' )
 
                       grid_x = 'x'
@@ -2521,17 +2547,28 @@
                       grid_z = 'zw'
 
-!
-!--                soil grid
-                   CASE ( 'm_soil_xz', 't_soil_xz' )
-
-                      grid_x = 'x'
-                      grid_y = 'y'
-                      grid_z = 'zs'
-
                    CASE DEFAULT
+
+!
+!--                   Check for land surface quantities
+                      IF ( land_surface )  THEN
+                         CALL lsm_define_netcdf_grid( do2d(av,i), found,       &
+                                                      grid_x, grid_y, grid_z )
+                      ENDIF
+
+!
+!--                   Check for radiation quantities
+                      IF ( .NOT. found  .AND.  radiation )  THEN
+                         CALL radiation_define_netcdf_grid( do2d(av,i), found, &
+                                                            grid_x, grid_y,    &
+                                                            grid_z )
+                      ENDIF
+
 !
 !--                   Check for user-defined quantities
-                      CALL user_define_netcdf_grid( do2d(av,i), found, &
-                                                    grid_x, grid_y, grid_z )
+                      IF ( .NOT. found )  THEN
+                         CALL user_define_netcdf_grid( do2d(av,i), found,      &
+                                                       grid_x, grid_y, grid_z )
+                      ENDIF
+
                       IF ( .NOT. found )  THEN
                          WRITE ( message_string, * ) 'no grid defined for', &
@@ -3137,7 +3174,5 @@
                           'prr_yz', 'pt_yz', 'q_yz', 'qc_yz', 'ql_yz',         &
                           'ql_c_yz', 'ql_v_yz', 'ql_vp_yz', 'qr_yz', 'qv_yz',  &
-                          'rad_lw_cs_hr_yz', 'rad_lw_hr_yz',                   &
-                          'rad_sw_cs_hr_yz', 'rad_sw_hr_yz''rho_yz', 's_yz',   &
-                          'sa_yz', 'vpt_yz' )
+                          'rho_yz', 's_yz', 'sa_yz', 'vpt_yz' )
 
                       grid_x = 'x'
@@ -3160,23 +3195,33 @@
 !
 !--                w grid
-                   CASE ( 'rad_lw_in_yz', 'rad_lw_out_yz', 'rad_sw_in_yz',     &
-                          'rad_sw_out_yz', 'w_yz' )
+                   CASE ( 'w_yz' )
 
                       grid_x = 'x'
                       grid_y = 'y'
                       grid_z = 'zw'
-!
-!--                soil grid
-                   CASE ( 'm_soil_yz', 't_soil_yz' )
-
-                      grid_x = 'x'
-                      grid_y = 'y'
-                      grid_z = 'zs'
+
 
                    CASE DEFAULT
 !
+!--                   Check for land surface quantities
+                      IF ( land_surface )  THEN
+                         CALL lsm_define_netcdf_grid( do2d(av,i), found,       &
+                                                      grid_x, grid_y, grid_z )
+                      ENDIF
+
+!
+!--                   Check for radiation quantities
+                      IF ( .NOT. found  .AND.  radiation )  THEN
+                         CALL radiation_define_netcdf_grid( do2d(av,i), found, &
+                                                            grid_x, grid_y,    &
+                                                            grid_z )
+                      ENDIF
+
+!
 !--                   Check for user-defined quantities
-                      CALL user_define_netcdf_grid( do2d(av,i), found, &
-                                                    grid_x, grid_y, grid_z )
+                      IF ( .NOT. found )  THEN
+                         CALL user_define_netcdf_grid( do2d(av,i), found,      &
+                                                       grid_x, grid_y, grid_z )
+                      ENDIF
 
                       IF ( .NOT. found )  THEN
@@ -4313,5 +4358,5 @@
 !--                Check for user-defined quantities (found, grid_x and grid_y
 !--                are dummies)
-                   CALL user_define_netcdf_grid( data_output_sp(i), found,  &
+                   CALL user_define_netcdf_grid( data_output_sp(i), found,     &
                                                  grid_x, grid_y, grid_z )
 
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1975)
+++ palm/trunk/SOURCE/palm.f90	(revision 1976)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added call to radiation_last_actions for binary output of land surface model 
+! data
 ! 
 ! Former revisions:
@@ -134,4 +135,6 @@
 !> machines are controlled via cpp-directives.
 !> Model runs are only feasible using the ksh-script mrun.
+!>
+!> @todo create routine last_actions instead of calling lsm_last_actions etc.
 !------------------------------------------------------------------------------!
  PROGRAM palm
@@ -182,4 +185,7 @@
         ONLY:  cpl_id, nested_run, pmci_child_initialize, pmci_init,           &
                pmci_modelconfiguration, pmci_parent_initialize
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  radiation, radiation_last_actions
 
     USE statistics,                                                            &
@@ -376,5 +382,4 @@
     ENDIF
 
-
 !
 !-- Output of program header
@@ -394,4 +399,5 @@
        CALL data_output_2d( 'yz', 0 )
     ENDIF
+
     IF ( do3d_at_begin )  THEN
        CALL data_output_3d( 0 )
@@ -458,4 +464,7 @@
              CALL lsm_last_actions
           ENDIF
+          IF ( radiation )  THEN
+             CALL radiation_last_actions
+          ENDIF
           CALL user_last_actions
           IF ( write_binary(1:4) == 'true' )  CALL close_file( 14 )
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1975)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1976)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Simplied calls to radiation model
 ! 
 ! Former revisions:
@@ -305,5 +305,5 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_scheme, radiation_tendency,                &
+        ONLY:  radiation, radiation_tendency,                                  &
                skip_time_do_radiation
 
@@ -638,5 +638,5 @@
 !
 !--          If required, add tendency due to radiative heating/cooling
-             IF ( radiation .AND. radiation_scheme == 'rrtmg' .AND.            &
+             IF ( radiation  .AND.                                             &
                   simulated_time > skip_time_do_radiation )  THEN
                 CALL radiation_tendency ( i, j, tend )
@@ -1371,5 +1371,5 @@
 !
 !--    If required, add tendency due to radiative heating/cooling
-       IF ( radiation .AND. radiation_scheme == 'rrtmg' .AND.                  &
+       IF ( radiation  .AND.                                                   &
             simulated_time > skip_time_do_radiation )  THEN
             CALL radiation_tendency ( tend )
@@ -2293,5 +2293,5 @@
        ENDIF
 
-       IF ( radiation .AND. radiation_scheme == 'rrtmg' .AND.                  &
+       IF ( radiation .AND.                                                    &
             simulated_time > skip_time_do_radiation )  THEN
             CALL radiation_tendency ( tend )
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 1975)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 1976)
@@ -19,5 +19,8 @@
 ! Current revisions:
 ! -----------------
-! 
+! Output of 2D/3D/masked data is now directly done within this module. The
+! radiation schemes have been simplified for better usability so that
+! rad_lw_in, rad_lw_out, rad_sw_in, and rad_sw_out are available independent of
+! the radiation code used.
 ! 
 ! Former revisions:
@@ -130,5 +133,4 @@
 
 #if defined ( __rrtmg )
-
     USE parrrsw,                                                               &
         ONLY:  naerec, nbndsw
@@ -276,5 +278,6 @@
 !
 !-- Flag parameters for RRTMGS (should not be changed)
-    INTEGER(iwp), PARAMETER :: rrtm_inflglw  = 2, & !< flag for lw cloud optical properties (0,1,2)
+    INTEGER(iwp), PARAMETER :: rrtm_idrv     = 1, & !< flag for longwave upward flux calculation option (0,1)
+                               rrtm_inflglw  = 2, & !< flag for lw cloud optical properties (0,1,2)
                                rrtm_iceflglw = 0, & !< flag for lw ice particle specifications (0,1,2,3)
                                rrtm_liqflglw = 1, & !< flag for lw liquid droplet specifications
@@ -289,6 +292,5 @@
     INTEGER(iwp) :: nzt_rad,           & !< upper vertical limit for radiation calculations
                     rrtm_icld = 0,     & !< cloud flag (0: clear sky column, 1: cloudy column)
-                    rrtm_iaer = 0,     & !< aerosol option flag (0: no aerosol layers, for lw only: 6 (requires setting of rrtm_sw_ecaer), 10: one or more aerosol layers (not implemented)
-                    rrtm_idrv = 1        !< longwave upward flux calculation option (0,1)
+                    rrtm_iaer = 0        !< aerosol option flag (0: no aerosol layers, for lw only: 6 (requires setting of rrtm_sw_ecaer), 10: one or more aerosol layers (not implemented)
 
     INTEGER(iwp) :: nc_stat !< local variable for storin the result of netCDF calls for error message handling
@@ -385,4 +387,28 @@
     END INTERFACE radiation_constant
  
+    INTERFACE radiation_control
+       MODULE PROCEDURE radiation_control
+    END INTERFACE radiation_control
+
+    INTERFACE radiation_3d_data_averaging
+       MODULE PROCEDURE radiation_3d_data_averaging
+    END INTERFACE radiation_3d_data_averaging
+
+    INTERFACE radiation_data_output_2d
+       MODULE PROCEDURE radiation_data_output_2d
+    END INTERFACE radiation_data_output_2d
+
+    INTERFACE radiation_data_output_3d
+       MODULE PROCEDURE radiation_data_output_3d
+    END INTERFACE radiation_data_output_3d
+
+    INTERFACE radiation_data_output_mask
+       MODULE PROCEDURE radiation_data_output_mask
+    END INTERFACE radiation_data_output_mask
+
+    INTERFACE radiation_define_netcdf_grid
+       MODULE PROCEDURE radiation_define_netcdf_grid
+    END INTERFACE radiation_define_netcdf_grid
+
     INTERFACE radiation_header
        MODULE PROCEDURE radiation_header
@@ -406,4 +432,12 @@
     END INTERFACE radiation_tendency
 
+    INTERFACE radiation_read_restart_data
+       MODULE PROCEDURE radiation_read_restart_data
+    END INTERFACE radiation_read_restart_data
+
+    INTERFACE radiation_last_actions
+       MODULE PROCEDURE radiation_last_actions
+    END INTERFACE radiation_last_actions
+
     SAVE
 
@@ -411,12 +445,15 @@
 
 !
-!-- Public functions
+!-- Public functions / NEEDS SORTING
     PUBLIC radiation_check_data_output, radiation_check_data_output_pr,        &
-           radiation_check_parameters, radiation_clearsky, radiation_constant, &
-           radiation_header, radiation_init, radiation_parin, radiation_rrtmg, &
-           radiation_tendency
+           radiation_check_parameters, radiation_control,                      &
+           radiation_header, radiation_init, radiation_parin,                  &
+           radiation_3d_data_averaging, radiation_tendency,                    &
+           radiation_data_output_2d, radiation_data_output_3d,                 &
+           radiation_define_netcdf_grid, radiation_last_actions,               &
+           radiation_read_restart_data, radiation_data_output_mask
     
 !
-!-- Public variables and constants
+!-- Public variables and constants / NEEDS SORTING
     PUBLIC dots_rad, dt_radiation, force_radiation_call,                       &
            rad_net, rad_net_av, radiation, radiation_scheme, rad_lw_in,        &
@@ -424,13 +461,43 @@
            rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av, rad_sw_in,  &
            rad_sw_in_av, rad_sw_out, rad_sw_out_av, rad_sw_cs_hr,              &
-           rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av, sigma_sb,                 &
+           rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av,                           &
            skip_time_do_radiation, time_radiation, unscheduled_radiation_calls
 
 
 #if defined ( __rrtmg )
-    PUBLIC rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir, rrtm_idrv
+    PUBLIC rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir
 #endif
 
  CONTAINS
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This subroutine controls the calls of the radiation schemes
+!------------------------------------------------------------------------------!
+    SUBROUTINE radiation_control
+ 
+ 
+       IMPLICIT NONE
+
+
+       SELECT CASE ( TRIM( radiation_scheme ) )
+
+          CASE ( 'constant' )
+             CALL radiation_constant
+          
+          CASE ( 'clear-sky' )
+             CALL radiation_clearsky
+       
+          CASE ( 'rrtmg' )
+             CALL radiation_rrtmg
+
+          CASE DEFAULT
+
+       END SELECT
+
+
+    END SUBROUTINE radiation_control
 
 !------------------------------------------------------------------------------!
@@ -456,6 +523,5 @@
        SELECT CASE ( TRIM( var ) )
 
-         CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_lw_cs_hr', 'rad_lw_hr',       &
-                 'rad_sw_in', 'rad_sw_out', 'rad_sw_cs_hr', 'rad_sw_hr' )
+         CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_sw_cs_hr', 'rad_sw_hr' )
              IF (  .NOT.  radiation  .OR.  radiation_scheme /= 'rrtmg' )  THEN
                 message_string = '"output of "' // TRIM( var ) // '" requi' // &
@@ -779,14 +845,6 @@
        ENDIF
 
-
-       IF ( radiation_scheme == 'constant' )  THEN
-
-          IF ( .NOT. ALLOCATED ( rad_lw_out ) )  THEN
-             ALLOCATE ( rad_lw_out(0:0,nysg:nyng,nxlg:nxrg) )
-          ENDIF
-
-       ENDIF
-
-       IF ( radiation_scheme == 'clear-sky' )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.                              &
+            radiation_scheme == 'constant')  THEN
 
           ALLOCATE ( alpha(nysg:nyng,nxlg:nxrg) )
@@ -1075,4 +1133,8 @@
                             + rad_lw_in(0,j,i) - rad_lw_out(0,j,i)
 
+
+             rad_lw_out_change_0(j,i) = 3.0_wp * sigma_sb * emissivity         &
+                                        * (pt(k,j,i) * exn) ** 3
+
           ENDDO
        ENDDO
@@ -1093,4 +1155,5 @@
        INTEGER(iwp) :: i, j, k   !< loop indices
        REAL(wp)     :: exn,   &  !< Exner functions at surface
+                       exn1,  &  !< Exner functions at first grid level
                        pt1       !< potential temperature at first grid level
 
@@ -1099,6 +1162,5 @@
        exn = (surface_pressure / 1000.0_wp )**0.286_wp
 !
-!--    Prescribe net radiation and estimate a longwave outgoing radiative
-!--    flux (needed in land surface model)
+!--    Prescribe net radiation and estimate the remaining radiative fluxes
        DO i = nxlg, nxrg
           DO j = nysg, nyng
@@ -1106,5 +1168,19 @@
 
              rad_net(j,i)      = net_radiation
+
+             exn1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
+
+             IF ( cloud_physics )  THEN
+                pt1 = pt(k+1,j,i) + l_d_cp / exn1 * ql(k+1,j,i)
+                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt1 * exn1)**4
+             ELSE
+                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt(k+1,j,i) * exn1)**4
+             ENDIF
+
              rad_lw_out(0,j,i) = emissivity * sigma_sb * (pt(k,j,i) * exn)**4
+
+             rad_sw_in(0,j,i) = ( rad_net(j,i) - rad_lw_in(0,j,i)              &
+                                  + rad_lw_out(0,j,i) )                        &
+                                  / ( 1.0_wp - alpha(j,i) )
 
           ENDDO
@@ -2147,24 +2223,25 @@
 !> Cache-optimized version.
 !------------------------------------------------------------------------------!
-    SUBROUTINE radiation_tendency_ij ( i, j, tend )
-
-       USE cloud_parameters,                                                   &
-           ONLY:  pt_d_t
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) :: i, j, k !< loop indices
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend !< pt tendency term
-
-#if defined ( __rrtmg )
+ SUBROUTINE radiation_tendency_ij ( i, j, tend )
+
+    USE cloud_parameters,                                                      &
+        ONLY:  pt_d_t
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: i, j, k !< loop indices
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend !< pt tendency term
+
+    IF ( radiation_scheme == 'rrtmg' )  THEN
+#if defined  ( __rrtmg )
 !
 !--    Calculate tendency based on heating rate
        DO k = nzb+1, nzt+1
           tend(k,j,i) = tend(k,j,i) + (rad_lw_hr(k,j,i) + rad_sw_hr(k,j,i))    &
-                                      * pt_d_t(k) * d_seconds_hour
+                                         * pt_d_t(k) * d_seconds_hour
        ENDDO
-
 #endif
+    ENDIF
 
     END SUBROUTINE radiation_tendency_ij
@@ -2177,19 +2254,20 @@
 !> Vector-optimized version
 !------------------------------------------------------------------------------!
-    SUBROUTINE radiation_tendency ( tend )
-
-       USE cloud_parameters,                                                   &
-           ONLY:  pt_d_t
-
-       USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) :: i, j, k !< loop indices
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend !< pt tendency term
-
-#if defined ( __rrtmg )
+ SUBROUTINE radiation_tendency ( tend )
+
+    USE cloud_parameters,                                                      &
+        ONLY:  pt_d_t
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: i, j, k !< loop indices
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) :: tend !< pt tendency term
+
+    IF ( radiation_scheme == 'rrtmg' )  THEN
+#if defined  ( __rrtmg )
 !
 !--    Calculate tendency based on heating rate
